=== .github/workflows/sscb/requirements.txt ===
setuptools
wheel
